<!DOCTYPE html>
<html lang="cs">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Jak fungují techniky NarutoLARPu</title>
    <link rel="stylesheet" href="./post.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.9.0/styles/default.min.css" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.9.0/highlight.min.js"></script>
    <script type="module">
        for (const code of document.querySelectorAll('code')) {
            code.innerHTML = code.innerHTML.trim();
        }
        hljs.highlightAll();
        for (const inlineCode of document.querySelectorAll(':not(pre) > code')) {
            hljs.highlightBlock(inlineCode);
        }
    </script>
    <style>
        code.hljs {
            background-color: #fff;
            border-radius: 0.2rem;
            padding: 2px 5px;
        }
    </style>
</head>
<body>
    <main>
        <h1 id="top">Jak fungují techniky NarutoLARPu</h1>
        <p>
            Techniky a jejich infrastruktura jsou veřejně viditelné v repozitáři
            <a href="https://gitlab.com/narutolarp/database-public">gitlab.com/narutolarp/database-public</a>.
            Níže vysvětlím jak tento repozitář funguje.
        </p>


        <h2 id="player">Jak techniky vidí hráči</h2>
        <p>
            Začneme od konce, a to jak a kde jsou techniky zobrazeny. Máme 3 způsoby zobrazení:
        </p>
        <ul>
            <li> Skilltree - interaktivní zaklikávání schopností. Toto zobrazení hráč vidí ve svém profilu.
            <li> List - výpis schopností rozdělený podle stromu / speciální schopnosti.
            <li> Table - velká tabulka se zkráceným zápisem technik, určená k tisku a vyvěšení ve vesnici.
        </ul>
        <p>
            A máme 2 místa kde je možné techniky vidět online. (Ale samozřejmě je také možné techniky vidět
            na svém PC, viz další kapitola <a href="#local">Jak s technikami pracovat</a>)
        </p>
        <p>
            První místo je testovací web <strong>narutolarp.gitlab.io</strong> (na ročníku 23 byl používaný jako produkční
            protože jsem nestíhal :D). Tam se automaticky náhrává každá změna která se v repozitáři provede,
            takže <strong>může obsahovat i rozpracované změny</strong>. Tento web je určen spíše pro vývoj/testování/feedback,
            běžného hráče toto místo zajímat nemusí.
        </p>
        <ul>
            <li> <a href="https://narutolarp.gitlab.io/database-public/skilltree.html">narutolarp.gitlab.io/database-public/skilltree.html</a>
            <li> <a href="https://narutolarp.gitlab.io/database-public/list.html">narutolarp.gitlab.io/database-public/list.html</a>
            <li> <a href="https://narutolarp.gitlab.io/database-public/table.html">narutolarp.gitlab.io/database-public/table.html</a>
        </ul>
        <p>
            Druhé místo je samotný web <strong>narutolarp.cz</strong>, kam putují jen vybrané verze technik
            (každá verze zde má své číslo, např 10.6 je verze na které se hrál ročník 2023).
            Současná oficiální verze technik je vždy k prokliknutí na stránce Informace
            <a href="https://narutolarp.cz/rules.php#rules_3">narutolarp.cz/rules.php#rules_3</a>.
            <br>Např pro verzi 10.6 tyto odkazy vypadají takto:
        </p>
        <ul>
            <li> <a href="https://narutolarp.cz/database-public/10.6/skilltree.html">narutolarp.cz/database-public/10.6/skilltree.html</a>
            <li> <a href="https://narutolarp.cz/database-public/10.6/list.html">narutolarp.cz/database-public/10.6/list.html</a>
            <li> <a href="https://narutolarp.cz/database-public/10.6/table.html">narutolarp.cz/database-public/10.6/table.html</a>
        </ul>



        <h2 id="local">Jak s technikami pracovat</h2>
        <aside>
            <p>
                Pro lidi co už ví která bije je to stručně popsané v
                <a href="https://gitlab.com/narutolarp/database-public/-/blob/master/README.md">README</a>
                repozitáře.
            </p>
        </aside>
        <p>
            V první řadě je nutné mít
            <a href="https://gitlab.com/users/sign_in">účet na gitlab.com</a>.
        </p>
        <p>
            Nejjednoduší způsob jak udělat změnu je přes webové rozhraní gitlabu.
            To je vhodné na menší změny, opravy textů, drobné balancování (změny čísel), etc.
            <br>
            Udělal jsem pár screenshotů:
            <a href="./web-ui.html">Jak editovat přes webové rozhraní (krok za krokem)</a>.
        </p>
        <p>
            Ale pro větší změny je lepší si repozitíř stáhnout na svůj PC, a pracovat tzv lokálně.
        </p>

        <details>
            <summary>Co je potřeba k lokální práci s technikama</summary>
            <ul>
                <li> git
                    (<a href="https://git-scm.com/downloads">git-scm.com/downloads</a> nebo <a href="https://gitforwindows.org/">gitforwindows.org</a>)
                    pro stažení repozitáře, a pro následné nahrávání změn.
                <li> nějaký editor - samozřejmě stačí jen poznámkový blok, ale pro efektivnější práci je lepší jakýkoli textový editor,
                    který má podporu pro XML+XSD (aby uměl našeptávat, a podtrhul případné chyby).
                    <br>
                    Např:
                    (<a href="https://code.visualstudio.com/">VSCode</a> + <a href="https://marketplace.visualstudio.com/items?itemName=redhat.vscode-xml">plugin na XML</a>)
                    nebo
                    <a href="https://microsoft.github.io/XmlNotepad/install/">XMLNotepad</a>.
                    Ale samozřejmě existuje spousta jiných možností.
                <li> <a href="https://wiki.python.org/moin/BeginnersGuide/Download">jazyk Python</a> (3.11 nebo novější)
                <li> <a href="https://guide.elm-lang.org/install/elm">jazyk Elm</a>
                <li> nějaký shell (příkazový řádek / terminál) -
                    Linux a MacOS už mají v základu,
                    na Windows třeba <a href="https://gitforwindows.org/#bash">Git Bash</a>
                    (který je součástí installace gitu pro Windows, viz první bod),
                    nebo pro odvážnější <a href="https://learn.microsoft.com/en-us/windows/wsl/install">WSL</a>.
                <li> přečíst si
                    <a href="https://gitlab.com/narutolarp/database-public/-/blob/master/README.md">README</a>
                    repozitáře
            </ul>
        </details>


        <h2 id="data">Definice technik (XML)</h2>

        <p>
            Začátkem všeho je definice technik. Tedy jak se techniky zapisují, a jak jsou uložené.
            Oprostíme se zcela od pomocných textů, nápověd a formátování, a zaměříme se pouze na to, co
            technika skutečně je: tedy kolik dává zranění, kolik stojí chakry, jak se sesílá,
            jak se jmenuje, apod.
            <br>
            Techniky jsou uložené ve složce 
            <a href="https://gitlab.com/narutolarp/database-public/-/tree/master/public/data?ref_type=heads">/public/data</a>
            a jsou zapsané v jazyku XML, rozdělené do několika XML souborů.
        </p>

        <h3>Soubor definice.xml</h3>
        <p>
            První je soubor
            <a href="https://gitlab.com/narutolarp/database-public/-/blob/master/public/data/definice.xml?ref_type=heads">definice.xml</a>,
            který obsahuje definice důležitých pojmů. Zde je pro nás hlavní atribut <i>id</i> který budeme potřebovat
            při definici technik samotných.
        </p>
        <div class="sbs">
            <figure>
                <figcaption>Definice zásahu rukou</figcaption>
                <pre><code class="language-xml">
&lt;zásah id="ruka">
    &lt;jméno>Rukou&lt;/jméno>
    &lt;popisek>Zásah bezezbraně. Předloktí musí být oděno
        měkčeným chráničem a zásah nesmí býtveden zatnutou
        pěstí.&lt;/popisek>
&lt;/zásah>
                </code></pre>
            </figure>

            <figure>
                <figcaption>Definice skrytí</figcaption>
                <pre><code class="language-xml">
&lt;klíčové-slovo id="skrytí">
    &lt;jméno>Skrytí&lt;/jméno>
    &lt;popisek>úroveň skrytí je znázorněna zdviženou rukou s příslušným počtem zvednutých
        prstů nebo nasazenou barevnou stuhou (1 = zelená, 2 = žlutá, 3 = červená).
        Technika a efekt skrytí končí když skrytá postava obdrží nebo udělí platný zásah,
        nebo se dotkne herního předmětu který již nemá u sebe.&lt;/popisek>
&lt;/klíčové-slovo>
                </code></pre>
            </figure>
        </div>


        <h3>Soubor specialni-schopnosti.xml</h3>

        <p>
            Druhý je soubor
            <a href="https://gitlab.com/narutolarp/database-public/-/blob/master/public/data/specialni-schopnosti.xml?ref_type=heads">specialni-schopnosti.xml</a>,
            který definuje všechny speciální schopnosti ve hře, a do kterých vesnic patří.
            Opět má každá speciální schopnost svoje <i>id</i>, na které se budeme později odkazovat
            (<code class="language-ini">id="opila-pest"</code>)
        </p>
        <div class="sbs">
            <figure>
                <figcaption>Definice speciální schopnosti Opilá pěst</figcaption>
                <pre><code class="language-xml">
&lt;quirk-mechanicky value="2" id="opila-pest" není-ve-hře="true">
    &lt;name>Opilá pěst&lt;/name>
    &lt;playstyle> několik technik, primárně boj beze zbraně &lt;/playstyle>
    &lt;village ref="valley">
        &lt;flavour>Toto je styl taijutsu, který je možný pouze tehdy, když je
            uživatel pod vlivem ...&lt;/flavour>
    &lt;/village>
&lt;/quirk-mechanicky>
                </code></pre>
            </figure>
            <figure>
                <figcaption>Zobrazení speciální schopnosti Opilá pěst</figcaption>
                <img src="./opila-pest.png" alt="Screnshot techniky Potácení" style="max-width: 35rem">
            </figure>
        </div>


        <h3>Soubory strom-*.xml</h3>

        <p>
            A nakonec je zde jeden soubor pro každý strom.
            V těchto souborech jsou definovány samotné techniky.
            Například soubor
            <a href="https://gitlab.com/narutolarp/database-public/-/blob/master/public/data/strom-Taijutsu.xml?ref_type=heads">strom-Taijutsu.xml</a>,
            který definuje strom Taijutsu, neboli Boj beze zbraně. Každý strom má taky své <i>id</i>,
            ale navíc ma definice všech technik, a to jak speciálních, tak veřejných.
            <br>
            Níže vidíme srovnání definice a zobrazení u jedné konkrétní techniky.
            Všimněme si následujících míst:
        </p>
        <ul>
            <li> <code class="language-xml">&lt;zásah ref="ruka" /></code>
                se odkazuje na
                <code class="language-xml">&lt;zásah id="ruka"></code>
                který jsme viděli v souboru definice.xml
                <ul>
                    <li> Zobrazí se jako text <i>"Když dostaneš útok typu: Rukou, ..."</i>
                        <br>
                        (kde <i>"Rukou"</i>
                        je hodnota
                        <code class="language-xml">&lt;jméno>Rukou&lt;/jméno></code>
                        ze souboru definice.xml)
                    <li>Pokud bychom chtěli <i>"Roukou"</i> přejmenovat na <i>"Beze zbraně"</i>,
                        stačí v souboru definice.xml napsat
                        <code class="language-xml">&lt;jméno>Beze zbraně&lt;/jméno></code>
                        a <i>id</i> nechat stejné.
                        <br>
                        Poté se u všech technik zobrazí
                        <i>"Když dostaneš útok typu: Beze zbraně, ..."</i>
                        <br>
                        &rarr; Tedy změna na jednom místě se propsala do všech technik.
                        <br>
                        (Ale v technice by stále bylo 
                        <code class="language-xml">&lt;zásah ref="ruka" /></code>
                        protože <i>id</i> jsme nezměnili)
                </ul>
            <li> <code class="language-xml">&lt;speciální-schopnost ref="opila-pest" /></code>
                se zobrazí jako šedý text <i>"Speciální schopnost: Opilá pěst"</i>, opět na základě souboru
                specialni-schopnosti.xml
                <ul>
                    <li> Opět by v souboru specialni-schopnosti.xml stačilo přejmenovat
                        <code class="language-xml">&lt;name>Opilá pěst&lt;/name></code>
                        na 
                        <code class="language-xml">&lt;name>Opilcova pěst&lt;/name></code>
                        a změna by se projevila ve všech technikách, které pod tuto speciální schopnost patří.
                        <br>
                        (Ale v technice by stále bylo
                        <code class="language-xml">&lt;speciální-schopnost ref="opila-pest" /></code>
                        protože <i>id</i> jsme nezměnili)
                </ul>
            <li> Obecně tedy: <i>ref</i> se odkazuje na <i>id</i>, a <i>id</i> může být jiné než
                jméno které vidí hráč
            <li> Ale text <i>"Když dostaneš útok typu"</i> není z žádného xml souboru.
                K jeho změně by se musel upravit soubor
                <a href="https://gitlab.com/narutolarp/database-public/-/blob/master/skilltree/src/JutsuEffect.elm?ref_type=heads">/skilltree/src/JutsuEffect.elm</a>
                (více v kapitole <a href="#skilltree">Zobrazení technik</a>)
        </ul>
        <div class="sbs">
            <figure>
                <figcaption>Definice techniky Potácení</figcaption>
                <pre><code class="language-xml">
&lt;technika id="technika-potaceni">
    &lt;jméno>Potácení&lt;/jméno>
    &lt;úroveň>5&lt;/úroveň>
    &lt;typ-efektu ref="posílení" />
    &lt;cena ref="život">1&lt;/cena>
    &lt;speciální-schopnost ref="opila-pest" />
    &lt;flavour />
    &lt;pasivní>
        &lt;atribut ref="max-život">1&lt;/atribut>
    &lt;/pasivní>
    &lt;obranná>
        &lt;zásah ref="ruka" />
        &lt;zásah ref="zbraň-nablízko" />
        &lt;zásah ref="zbraň-nadálku" />
        &lt;zásah ref="koule" />
        &lt;heslo ref="úhyb" />
    &lt;/obranná>
&lt;/technika>
                </code></pre>
            </figure>
            <figure>
                <figcaption>Zobrazení techniky Potácení</figcaption>
                <img src="./potaceni.png" alt="Screnshot techniky Potácení" style="max-width: 35rem">
            </figure>
        </div>

        <aside>
            <p>
                Obecně není dobrý nápad jakékoliv <i>id</i> měnit. Na konkrétní <i>id</i> se
                mohou spoléhat různé techniky, které by také bylo potřeba změnit.
                Navíc je možné že stará hodnota <i>id</i> je uložena někde mimo tento repozitář.
                Např zvolené techniky hráčů jsou uloženy pomocí <i>id</i> technik, takže pokud
                bychom změnili <i>id</i> některé techniky, tak by hráči který ji měl zvolenou
                najednou zmizela.
            </p>
            <p>
                Ale v případech kdy se některé <i>id</i> přesto změní, nebo se přídá nové <i>id</i>
                (nová technika, nové heslo, etc), nebo se některé smaže:
                <br>
                Je nutné spustit skript
                <a href="https://gitlab.com/narutolarp/database-public/-/blob/master/utils/generate_enums.py?ref_type=heads">/utils/generate_enums.py</a>
            </p>
        </aside>


        <h2 id="schemas">XML Schema (XSD)</h2>
        <p>
            Každý XML soubor má své schéma, tedy soubor který určuje co v něm může být
            a co ne. Schémata jsou ve složce
            <a href="https://gitlab.com/narutolarp/database-public/-/tree/master/public/data/schemas?ref_type=heads">/public/data/schemas</a>.
            Při změně schématu je typicky potřeba změnit i dotčené XML soubor/y,
            a změnit i zobrazovací logiku, aby byla schopná přijmat nové schéma
            (složka <a href="https://gitlab.com/narutolarp/database-public/-/tree/master/skilltree?ref_type=heads">/skilltree</a>).
        </p>


        <h2 id="skilltree">Zobrazení technik (Elm)</h2>
        <p>
            To jak se techniky zobrazují je definováné ve složce
            <a href="https://gitlab.com/narutolarp/database-public/-/tree/master/skilltree?ref_type=heads">/skilltree</a>.
        </p>


        <h2>Plány do budoucna</h2>
        <p>
            Kompletně strukturuovat techniky (textové části přenést do struktury).
        </p>
        <p>
            Provádět analýzu nad technikami.
        </p>
        <p>
            Zlepšit tento článek.
        </p>


        <h2>Motivace pro zvolené technologie</h2>
        <ul>
            <li> Díky <a href="https://en.wikipedia.org/wiki/Git">gitu</a> máme kompletní historii všech změn,
                a to jak technik, tak infrastruktury kolem nich.
            <li> Gitlab Pipelines nám umožní automatizovat některé procesy, čímž jednak
                šetří čas, ale hlavně nejsou náchylné na lidskou chybu (která se při otevírání
                registrace ve 2 ráno může stát velmi snadno).
            <li> <a href="https://en.wikipedia.org/wiki/Xml">XML</a> nám umožní oddělit definici techniky od
                její prezentace.
                Je pak snadné dělat plošné změny toho jak se techniky zobrazují, aniž by se muselo
                manuálně přepisovat 200 technik.
            <li> <a href="https://en.wikipedia.org/wiki/Xsd">XSD</a> schémata kontrolují jak jsou techniky nadefinovány.
                V první řadě je to pomocník při psaní technik - chrání před překlepy, a napovídá jak techniku zapsat.
                V druhé řadě je to kontrolor, který omezuje aby nebylo možné napsat techniku, která
                nezapadá do zbytku systému.
            <li> Zobrazování technik je řešeno zcela v prohlížeči, což usnadňuje vývoj, a umožňuje
                techniky snadno testovat na
                <a href="https://narutolarp.gitlab.io/database-public/">narutolarp.gitlab.io/database-public</a>.
                Zobrazení je psané v jazyku <a href="https://elm-lang.org/">Elm</a>, který je skvělý na zapisování
                složité funkcionality která se často mění.
            <li> Menší pomocné skripty jsou psané v jazyku <a href="https://www.python.org/">Python</a>,
                který jde snadno nainstalovat na každém OS (a leckdo ho už má nainstalovaný).
                Plus ho většina lidí zná, a malé skripty se v něm píší rychle.
        </ul>
    </main>
</body>
</html>
